unit RepresentativesO;

interface
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls,TeEngine,Math,
     Init, t_dtO, Unit1,Unit4,Unit6,Unit10,MathMyO,
     typeNrnParsO, NeuronO, CreateNrnO, SetNrnParsO,Correspond,
     ConnectionsO,ColumnO,PopulationO,slice_2DO;

procedure InheriteFewVarsToRepresentativeNrnO(ANrn_from,ANrn_to :TNeuron);
function IfNonzero_iPop_for_i_Repr(i :integer; var iPop :integer) :boolean;
procedure InitiateRepresentativeNeuronsO;
procedure DestroyRepresentativeNeuronsO;
procedure PrepareFormForRepresentativeNeuronsO;
procedure OneStepForRepresentativeNeuronsO(Pt,Pdt :Pdouble);

var
  NP_,NP_tmp            :NeuronProperties;
  ANrns,BGNrns          :array[1..5] of TNeuron;
  Field_Of_ANrns        :array[0..mXmax,0..mYmax] of TNeuron;
  Inoise                :array[1..5] of double;
  rrr                   :text;

implementation
uses Stimulation;

procedure InheriteFewVarsToRepresentativeNrnO(ANrn_from,ANrn_to :TNeuron);
begin
  ANrn_to.NP.VL  :=ANrn_from.NP.VL;
  ANrn_to.NP.VLd :=ANrn_from.NP.VLd;
  ANrn_to.NP.VAHP:=ANrn_from.NP.VAHP;
  ANrn_to.NP.dVAHP:=ANrn_from.NP.dVAHP;
  ANrn_to.NP.VK  :=ANrn_from.NP.VK;
  ANrn_to.NP.VKDr:=ANrn_from.NP.VKDr;
  ANrn_to.NP.VKM :=ANrn_from.NP.VKM;
  ANrn_to.NP.VKD :=ANrn_from.NP.VKD;
  ANrn_to.NP.VNa :=ANrn_from.NP.VNa;
  ANrn_to.NP.gL  :=ANrn_from.NP.gL;
  ANrn_to.NP.NaKpumpS  :=ANrn_from.NP.NaKpumpS;
  ANrn_to.NP.NaKpumpD  :=ANrn_from.NP.NaKpumpD;
end;

function IfNonzero_iPop_for_i_Repr(i :integer; var iPop :integer) :boolean;
begin
  iPop:=i;
  if (i<>5)and(i>NPop) then iPop:=0;
  if i=5 then iPop:=i3;
  IfNonzero_iPop_for_i_Repr:=(iPop<>0);
end;

procedure InitiateRepresentativeNeuronsO;
{
  ANrns[1..NPop] are representative neurons of the populations.
  ANrns[5] is the recorded neuron.
}
var  i,j,ip :integer;
begin
  for i:=1 to 5 do if IfNonzero_iPop_for_i_Repr(i,ip) then begin
      NP_:=AColumn.Pop[ip].PP.NP;
      NP_.Thr_type:='Default-2';                            //14.05.2016
      case i of                                             //24.05.2019
      1,3: NP_.IfThrModel:=IfTrue(Form6.CheckBox22.Checked);
      2,4: NP_.IfThrModel:=IfTrue(Form6.CheckBox1.Checked);
      5:       NP_.IfThrModel:=R.NP.IfThrModel;
      end;
      //NP_.IfThrModel:=R.NP.IfThrModel;                      //introduced 19.05.2018
      if NP_.IfThrModel=0 then begin
         NP_.IfBlockNa:=0;
         NP_tmp:=NP_;
         DefaultCanalParameters(NP_tmp);
         NP_.gCaH:=0;
         NP_.gNa:=NP_tmp.gNa;
      end;
      case i of                                             //24.05.2019
      1,3: begin
             Iind_ReprNrnE:=Form6.DDSpinEdit3.Value; {pA}
             wE_ReprNrnE  :=Form6.DDSpinEdit7.Value;
             wI_ReprNrnE  :=Form6.DDSpinEdit9.Value;
             if NP_.IfThrModel=0 then begin
                if Form6.DDSpinEdit5.Value>0  then NP_.gK  :=Form6.DDSpinEdit5.Value;  {mS/cm^2}
                if Form6.DDSpinEdit11.Value>0 then NP_.gKCa:=Form6.DDSpinEdit11.Value; {mS/cm^2}  //17.03.2020
                NP_.NaThreshShift:=Form6.DDSpinEdit1.Value; {mV}                         //15.01.2020
                NP_.KThreshShift :=Form6.DDSpinEdit1.Value; {mV}                         //10.03.2020
             end else begin
                NP_.ThrShift :=Form6.DDSpinEdit1.Value/1000; {V}
             end;
           end;
      2,4: begin
             Iind_ReprNrnI:=Form6.DDSpinEdit4.Value; {pA}
             wE_ReprNrnI  :=Form6.DDSpinEdit8.Value;
             wI_ReprNrnI  :=Form6.DDSpinEdit10.Value;
             if NP_.IfThrModel=0 then begin
                if Form6.DDSpinEdit6.Value>0  then NP_.gK  :=Form6.DDSpinEdit6.Value;  {mS/cm^2}
                if Form6.DDSpinEdit12.Value>0 then NP_.gKCa:=Form6.DDSpinEdit12.Value; {mS/cm^2}  //17.03.2020
                NP_.NaThreshShift:=Form6.DDSpinEdit2.Value; {mV}                         //15.01.2020
                NP_.KThreshShift :=Form6.DDSpinEdit2.Value; {mV}                         //10.03.2020
             end else begin
                NP_.ThrShift :=Form6.DDSpinEdit2.Value/1000; {V}
             end;
           end;
      end;
      { If this representative neuron is the recorded one... }
      if i=5 then begin
         NP_.If_I_V_or_g:=R.NP.If_I_V_or_g;
         NP_.Vrest:=R.NP.Vrest;
         NP_.ThrShift:=R.NP.ThrShift;
         if R.NP.Square>0 then NP_.Square:=R.NP.Square;
         R.NP.Square:=NP_.Square;
      end;
      { Create an object and set initial conditions }
      CreateNeuronByTypeO(NP_, ANrns[i]);
      @ANrns[i].NP.IfSpikeOccursInThrModel:=nil;
      ANrns[i].InitialConditions;
      { BG }
      if (IfBGColumnCreated)and(IfBGinProcess=false) then
                            ANrns[i].EquateFrom(BGNrns[i]);
      {****}
      Inoise[i]:=0;
      CorrespondParametersToTheForm;
  end;
  {***}
  { 2D }
  if (IfRepresentative_2D=1)and(TaskToSolve='2D') then begin
     for i:=0 to ni+1 do begin
         for j:=0 to nj+1 do if if_ni_nj_ne_1(i,j) then begin
             { Create an object and set initial conditions }
             CreateNeuronByTypeO(NP_, Field_Of_ANrns[i,j]);
             @Field_Of_ANrns[i,j].NP.IfSpikeOccursInThrModel:=nil;
             Field_Of_ANrns[i,j].InitialConditions;
             Field_Of_ANrns[i,j].EquateFrom(ANrns[5]);
         end;
     end;
  end;
  { Drawing }
  Form6.Series1.Clear;
  Form6.Series2.Clear;
  Form6.Series5.Clear;
  Form6.Series6.Clear;
  Form6.Series7.Clear;
  Form6.Series8.Clear;
  Form6.Series9.Clear;
  Form6.Series10.Clear;
  { Writing }
  assign(rrr,'Representatives_U_nu(t).dat'); rewrite(rrr); close(rrr);
end;

procedure DestroyRepresentativeNeuronsO;
var i,j :integer;
begin
  { Destruction }
  if nt>=nt_end then for i:=1 to 5 do begin
     ANrns[i].Free;
  end;
  { 2D }
  if (IfRepresentative_2D=1)and(TaskToSolve='2D') then begin
     for i:=0 to ni+1 do begin
         for j:=0 to nj+1 do if if_ni_nj_ne_1(i,j) then begin
             Field_Of_ANrns[i,j].Free;
         end;
     end;
  end;
end;

procedure PrepareFormForRepresentativeNeuronsO;
begin
  //Form1.CheckBox1.Checked:=true;
  //Form10.CheckBox5.Checked:=true;
  //Form6.Visible:=true;
{  Form6.Series1.Active:=false;
  Form6.Series2.Active:=false;}
  Form6.Chart1.Visible:=(NPop>=1);
  Form6.Chart2.Visible:=(NPop>=2);
  Form6.Chart4.Visible:=(NPop>=3);
  Form6.Chart5.Visible:=(NPop>=4);
  { If switch on when simulating, create an object and set initial conditions }
{  if nt>1 then begin
     InitiateRepresentativeNeuronsO;
  end;}
end;

function Current_Iind_InNeuron(t,Iind,Freq_Iind,
                               t_Iind,t_IindShift,Square :double) :double;
var  w,tp,t_ :double;
begin
  t_:=t-t_IindShift;
  if (t_>t0_ind) and (t_<=t0_ind+t_Iind) then begin
     if Freq_Iind=0 then begin
        w:=Iind;
        { Meander, negative part }
        if (Form4.ComboBox1.ItemIndex=3)and(t_>=t0_ind+t_Iind/2) then w:=-w;
     end else w:=Iind*sin(2*pi*Freq_Iind*t_);
     Result:=w/(Square*1e9);
  end else begin
     Result:=0;
  end;
  { Pulse train }
  if (Freq_Iind>0)and(t_Iind<0.005) then begin
     tp:=trunc(t_*Freq_Iind)/Freq_Iind;
     if (t_>tp)and(t_<tp+t_Iind)and(trunc(t_*Freq_Iind)<=10)
     then  Result:=Iind/(Square*1e9)
     else  Result:=0;
  end;
end;

{function Add_Iind(i :integer) :double;
begin
  if i=5 then begin
     Add_Iind:=Current_Iind_InNeuron(t,Iind_ReprNrn,nu_ind,t_ind,t0_ind,ANrns[5].NP.Square)
              +Current_Iind(i,AColumn.Pop[i3].r_noise);
  end else begin
     Add_Iind:=0;
  end;
end;}

procedure WriteRepresentative;
var i,ip     :integer;
begin
  append(rrr);
  write  (rrr,t*1000:8:4,' ');
  for i:=1 to 5 do if IfNonzero_iPop_for_i_Repr(i,ip) then
      write(rrr,ANrns[i].NV.V*1e3:9:5,' ',AColumn.Pop[ip].nu:8:2,' ');
  writeln(rrr);
  close(rrr);
end;

procedure OneStepForRepresentativeNeuronsO(Pt,Pdt :Pdouble);
var
    i,j,ip                                                :integer;
    Iinj_,Ampl_Noise,tau_Noise,x,s_gL,gL0,wE,wI         :double;
begin
  { At t=0 create an object and set initial conditions }
{  if nt=1 then begin
     InitiateRepresentativeNeuronsO;
  end;}
//  taum_taus:=Form4.DDSpinEdit98.Value;
  t:=Pt^;  dt:=Pdt^;
  for i:=1 to 5 do if IfNonzero_iPop_for_i_Repr(i,ip) then with AColumn.Pop[ip] do begin
      Iinj_:=Iind;//+Add_Iind(i);          { commented on 12.02.2019 }
      case i of                 // 24.05.2019
      1,3: Iinj_:=Iinj_ + Iind_ReprNrnE/(ANrns[i].NP.Square*1e9);
      2,4: Iinj_:=Iinj_ + Iind_ReprNrnI/(ANrns[i].NP.Square*1e9);
      5: Iinj_:=Iinj_+Current_Iind_InNeuron(t,Iind_RecNrn,nu_ind,t_ind,t0_ind,ANrns[5].NP.Square);   { added on 12.02.2019 }
      end;
      gL0:=PP.NP.C_membr/PP.NP.tau_m0;
      s_gL:=(sE+sI)/gL0;
      { Color Noise-current }
      Ampl_Noise:=PP.sgm_V*gL0;
      { Synaptic noise is proportional to synaptic conductance sgm=a+b*ss_, where we assume also a=b; }
      if PP.If_sgm_scaled_with_s=1 then Ampl_Noise:=Ampl_Noise*sqrt(1+s_gL); // sqrt is introduced on 25.02.2017
      if R.IfNoise=0 then Ampl_Noise:=0;
      if taum_taus=0 then tau_Noise:=0 else tau_Noise:=PP.NP.tau_m0/taum_taus;
      if tau_Noise=0 then begin
         Inoise[i]:=Ampl_Noise*sqrt(2*PP.NP.tau_m0  {/(1+s_gL)}  /dt)*randG(0,1);  //commented on 20.09.2012
      end else begin
         x:=Ampl_Noise*randG(0,1);
         Inoise[i]:=Inoise[i] - Inoise[i]/tau_Noise*dt + x*sqrt(2*dt/tau_Noise);
      end;
      { Define synaptic weights }
      wE:=1; wI:=1;
      case i of
      1,3: begin wE:=wE_ReprNrnE; wI:=wI_ReprNrnE; end;
      2,4: begin wE:=wE_ReprNrnI; wI:=wI_ReprNrnI; end;
      5:   begin wE:=R.SynapticWeightE; wI:=R.SynapticWeightI; end;
      end;
      {************** One step of integration ********************************************}
      ANrns[i].MembranePotential(wE*uE,wI*sE,wE*uI,wI*sI,wE*tt,Iinj_+Inoise[i],R.NP.Vrest);
      {***********************************************************************************}
  end;
  { 2D }
  if (IfRepresentative_2D=1)and(TaskToSolve='2D') then begin
     for i:=0 to ni+1 do begin
         for j:=0 to nj+1 do if if_ni_nj_ne_1(i,j) then with Columns[i,j].Pop[i3] do begin
             {************** One step of integration *******************************************************}
             Field_Of_ANrns[i,j].MembranePotential(wE*uE,wI*sE,wE*uI,wI*sI,wE*tt,Iinj_+Inoise[5],R.NP.Vrest);
             {**********************************************************************************************}
         end;
     end;
  end;
  { Draw }
  if (trunc(nt/n_show)=nt/n_show)or(nt=1) then begin
     if NPop>=1 then Form6.Series1.AddXY(t*1000,ANrns[1].NV.V*1000);
     if NPop>=2 then Form6.Series2.AddXY(t*1000,ANrns[2].NV.V*1000);
     if NPop>=3 then Form6.Series7.AddXY(t*1000,ANrns[3].NV.V*1000);
     if NPop>=4 then Form6.Series8.AddXY(t*1000,ANrns[4].NV.V*1000);
     if NPop>=1 then Form6.Series5.AddXY(t*1000,AColumn.Pop[1].nu);
     if NPop>=2 then Form6.Series6.AddXY(t*1000,AColumn.Pop[2].nu);
     if NPop>=3 then Form6.Series9.AddXY(t*1000,AColumn.Pop[3].nu);
     if NPop>=4 then Form6.Series10.AddXY(t*1000,AColumn.Pop[4].nu);
     //Application.ProcessMessages;
  end;
  { Write }
  if (trunc(nt/2)=nt/2)or(nt=1) then begin
      WriteRepresentative;
  end;
end;

end.

