unit LGN_main;

interface
uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
      Dialogs, Math,
      LGN_Init,LGN_stimulation,LGN_to_V1;

procedure LGN_Parameters;
procedure WriteParametersInFile;
procedure DrawReceptiveField;
procedure Write2D_zScreen_zview;
procedure CalculateAndWrite2DReceptiveField;
procedure LGN_InitialConditions;
function LGN_Screen_Projection_to_Cortex(r_V1,phi_V1 :double) :double;
procedure LGN_Draw_RF(r_V1,phi_V1,fi,charge :double);
procedure Define_z_view;
procedure WriteNonlinearFunction;
procedure LGN_RunOneStep(t_,dt_ :double);
procedure Translate_r_phi_V1_to_x_y_LGN(r,phi :double; var x,y :double);
procedure LGN_Draw(t_ :double);
procedure LGN_Draw_Retinotopy(r_0_0, phi_0_0,  r_0_nj, phi_0_nj,
                              r_ni_0,phi_ni_0, r_ni_nj,phi_ni_nj :double);
procedure RunTillTheEnd;
procedure RunEntireDiagram;

implementation
uses LGN_Unit1,LGN_Unit30,LGN_Lattice,MathMyO,LGN_Unit15,LGN_Unit33;

procedure LGN_Parameters;
var i,j :integer;
begin
  ni:=trunc(LGN_Form1.DDSpinEdit3.Value);
  nj:=trunc(LGN_Form1.DDSpinEdit4.Value);
  ni2_Screen:=trunc((ni+1)/2);
  nj2_Screen:=trunc((nj+1)/2);
  ni2_LGN   :=trunc((ni+1)/2);
  nj2_LGN   :=trunc((nj+1)/2);
  AmplOfStimLum    :=LGN_Form1.DDSpinEdit6.Value;
  MeanStimLum      :=LGN_Form1.DDSpinEdit27.Value;
  Background       :=LGN_Form1.DDSpinEdit17.Value;
  ScaleOfSaturation:=LGN_Form1.DDSpinEdit26.Value;
  ShapeOfSaturation:=LGN_Form1.ComboBox2.Items[LGN_Form1.ComboBox2.ItemIndex];
  DS_model         :=LGN_Form1.ComboBox3.ItemIndex;
  rPW :=6; { dummy }
  dxy_LGN:=LGN_Form1.DDSpinEdit7.Value{grad};
  V1_to_LGN_deg_per_mm:=LGN_Form1.DDSpinEdit29.Value{deg/mm};
  tau_cen   :=LGN_Form1.DDSpinEdit9.Value {ms}/1000;
  tau_sur   :=LGN_Form1.DDSpinEdit10.Value{ms}/1000;
  tau_late  :=LGN_Form1.DDSpinEdit30.Value{ms}/1000;
  K_late_to_early:=LGN_Form1.DDSpinEdit31.Value;
  sgm_cen_h :=LGN_Form1.DDSpinEdit11.Value{grad};
  sgm_cen_v1:=LGN_Form1.DDSpinEdit19.Value{grad};
  sgm_cen_v2:=LGN_Form1.DDSpinEdit28.Value{grad};
  sgm_sur_h :=LGN_Form1.DDSpinEdit12.Value{grad};
  sgm_sur_v :=LGN_Form1.DDSpinEdit25.Value{grad};
  k_cen_sur :=LGN_Form1.DDSpinEdit13.Value;
  L_spont   :=LGN_Form1.DDSpinEdit23.Value{Hz};
  sgm_pref  :=LGN_Form1.DDSpinEdit14.Value{grad};
  sgm_orth  :=LGN_Form1.DDSpinEdit15.Value{grad};
  Off_shift :=LGN_Form1.DDSpinEdit32.Value{grad};
  t_end     :=LGN_Form1.DDSpinEdit16.Value{ms}/1000;
  dt_LGN    :=LGN_Form1.DDSpinEdit18.Value{ms}/1000;
  t_stim    :=LGN_Form1.DDSpinEdit24.Value{ms}/1000;
  Diagram.Vert_shift :=LGN_Form1.DDSpinEdit20.Value{grad};
  Diagram.Horiz_shift:=LGN_Form1.DDSpinEdit21.Value{grad};
  Diagram.i_RecNrn:=ni2_LGN+trunc(Diagram.Horiz_shift/dxy_LGN);
  Diagram.j_RecNrn:=nj2_LGN+trunc(Diagram.Vert_shift /dxy_LGN);
  IfRunOneLGNneuron:=0;
  //if LGN_Form1.PageControl1.ActivePageIndex<>1 then IfRunOneLGNneuron:=1;
  if IfRunOneLGNneuron=1 then begin
     LGN_Form1.RadioGroup1.Items[4]:='';
     LGN_Form1.RadioGroup1.Items[5]:='';
     LGN_Form1.RadioGroup1.Items[6]:='';
     LGN_Form1.RadioGroup1.Items[7]:='';
     LGN_Form1.RadioGroup1.Items[9]:='';
  end else begin
     LGN_Form1.RadioGroup1.Items[4]:='zLGN_cen';
     LGN_Form1.RadioGroup1.Items[5]:='zLGN_sur';
     LGN_Form1.RadioGroup1.Items[6]:='zLGN_subthr';
     LGN_Form1.RadioGroup1.Items[7]:='zLGN';
     LGN_Form1.RadioGroup1.Items[9]:='zLGN_Off';
  end;
  { Complex Stimulus }
  LGN_Form30.Visible:=(LGN_Form1.ComboBox1.ItemIndex in [6,8])and(LGN_Form1.Visible);
  LGN_Form33.Visible:=(LGN_Form1.CheckBox2.Checked)and(LGN_Form1.Visible);
end;

procedure WriteParametersInFile;
var FName :string;
    Year, Month, Day, Hour, Min, Sec, MSec: Word;
    ccc :text;
    Frequency,Length,Radius_2,fi0,SpatPhase0 :double;
    t1 :string;
begin
  Frequency :=LGN_Form1.DDSpinEdit1.Value; {Hz}
  Length    :=LGN_Form1.DDSpinEdit2.Value{grad};
  Radius_2  :=LGN_Form1.DDSpinEdit22.Value{grad};
  fi0       :=LGN_Form1.DDSpinEdit5.Value{degrees}+90;
  SpatPhase0:=LGN_Form1.DDSpinEdit33.Value{degrees};
  Str(LGN_Form1.ComboBox1.ItemIndex:1,t1);
  { File name }
  DecodeTime(Now, Hour, Min, Sec, MSec);
  FName := IntToStr(Hour) + '_' + IntToStr(Min) + '_' + IntToStr(Sec)+'_Stimul='+t1+'.par';
  { Opening }
  assign(ccc,FName); rewrite(ccc);
  { Writing }
  write(ccc,'ni=');           writeln(ccc,'            ',ni:3,' ');
  write(ccc,'nj=');           writeln(ccc,'            ',nj:3,' ');
  write(ccc,'AmplOfStimLum=');     writeln(ccc,'            ',AmplOfStimLum:10:0,' ');
  write(ccc,'MeanStimLum=');       writeln(ccc,'            ',MeanStimLum:10:0,' ');
  write(ccc,'Background=');        writeln(ccc,'            ',Background:10:0,' ');
  write(ccc,'dxy_LGN=');        writeln(ccc,'            ',dxy_LGN:10:3,' ');
  write(ccc,'tau_cen=');        writeln(ccc,'            ',tau_cen*1e3:10:0,' ');
  write(ccc,'tau_sur=');        writeln(ccc,'            ',tau_sur*1e3:10:0,' ');
  write(ccc,'sgm_cen_h=');        writeln(ccc,'            ',sgm_cen_h:10:3,' ');
  write(ccc,'sgm_cen_v1=');        writeln(ccc,'            ',sgm_cen_v1:10:3,' ');
  write(ccc,'sgm_cen_v2=');        writeln(ccc,'            ',sgm_cen_v2:10:3,' ');
  write(ccc,'sgm_sur_h=');        writeln(ccc,'            ',sgm_sur_h:10:3,' ');
  write(ccc,'sgm_sur_v=');        writeln(ccc,'            ',sgm_sur_v:10:3,' ');
  write(ccc,'k_cen_sur=');        writeln(ccc,'            ',k_cen_sur:10:3,' ');
  write(ccc,'L_spont=');        writeln(ccc,'            ',L_spont:10:0,' ');
  write(ccc,'sgm_pref=');        writeln(ccc,'            ',sgm_pref:10:3,' ');
  write(ccc,'sgm_orth=');        writeln(ccc,'            ',sgm_orth:10:3,' ');
  write(ccc,'t_end=');        writeln(ccc,'            ',t_end*1e3:10:0,' ');
  write(ccc,'dt_LGN=');        writeln(ccc,'            ',dt_LGN*1e3:10:3,' ');
  write(ccc,'t_stim=');        writeln(ccc,'            ',t_stim*1e3:10:0,' ');
  write(ccc,'Vert_shift=');        writeln(ccc,'            ',Diagram.Vert_shift:10:3,' ');
  write(ccc,'Horiz_shift=');        writeln(ccc,'            ',Diagram.Horiz_shift:10:3,' ');
  write(ccc,'Frequency=');        writeln(ccc,'            ',Frequency:10:3,' ');
  write(ccc,'Length=');        writeln(ccc,'            ',Length:10:3,' ');
  write(ccc,'Radius_2=');        writeln(ccc,'            ',Radius_2:10:3,' ');
  write(ccc,'fi0=');        writeln(ccc,'            ',fi0:6:0,' ');
  write(ccc,'tau_late=');   writeln(ccc,'            ',tau_late*1e3:10:0,' ');
  write(ccc,'K_late_to_early=');   writeln(ccc,'            ',K_late_to_early:10:3,' ');
  write(ccc,'SpatPhase0=');   writeln(ccc,'            ',SpatPhase0:10:3,' ');
  close(ccc);
end;

procedure DrawReceptiveField;
var
    i,Ni_,nt :integer;
    f,f_cen,f_sur,y,t,Dcen_,Dsur_ :double;
    ppp,qqq :text;
begin
  { Opening }
  assign(ppp,'RF_profile.dat');  rewrite(ppp);
  assign(qqq,'RF_kinetics.dat'); rewrite(qqq);
  { Parameters }
  LGN_Parameters;
  {*** Profile *********}
  LGN_Form1.Series3.Clear;
  LGN_Form1.Series4.Clear;
  LGN_Form1.Series5.Clear;
  Ni_:=100;
  for i:=-Ni_ to Ni_ do begin
      y:=i*4/Ni_;
      if y<0 then begin
         f_cen:=         exp(-sqr(y/sgm_cen_v1));
      end else begin
         f_cen:=         exp(-sqr(y/sgm_cen_v2));
      end;
      f_cen:= f_cen/pi/(sgm_cen_h*(sgm_cen_v1+sgm_cen_v2)/2);
      f_sur:=-k_cen_sur/pi/(sgm_sur_h*sgm_sur_v)*exp(-sqr(y/sgm_sur_v));
      f    :=  f_cen + f_sur;
      LGN_Form1.Series3.AddXY(y,f);
      LGN_Form1.Series4.AddXY(y,f_cen);
      LGN_Form1.Series5.AddXY(y,f_sur);
      { Writing }
      writeln(ppp,y:9:5,' ',f:8:4,' ',f_cen:8:4,' ',f_sur:8:4);
  end;
  {*** Kinetics *********}
  LGN_Form1.Series6.Clear;
  LGN_Form1.Series7.Clear;
  Ni_:=100;
  for nt:=0 to Ni_ do begin
      t:=max(4*max(tau_cen,tau_sur),4*tau_late)*nt/Ni_;
      Dcen_:=t/sqr(tau_cen)*dexp(-t/tau_cen)
            - K_late_to_early*t/sqr(tau_late)*dexp(-t/tau_late);  //8.02.2016
      Dsur_:=t/sqr(tau_sur)*dexp(-t/tau_sur)
            - K_late_to_early*t/sqr(tau_late)*dexp(-t/tau_late);  //8.02.2016
      LGN_Form1.Series6.AddXY(t*1e3,Dcen_);
      LGN_Form1.Series7.AddXY(t*1e3,Dsur_);
      { Writing }
      writeln(qqq,t*1e3:9:5,' ',Dcen_:8:4,' ',Dsur_:8:4);
  end;
  Application.ProcessMessages;
  close(ppp);
  close(qqq);
end;

procedure CalculateAndWrite2DReceptiveField;
var i,j :integer;
    ccc,ddd :text;
    d_cen,d_sur,x,y :double;
begin
  { Opening }
  assign(ccc,'RF.dat'); rewrite(ccc);
  writeln(ccc,'ZONE T="RF.dat"');
  writeln(ccc,'I=',ni+2:3,',J=',nj+2:3,',K=1,F=POINT');
  assign(ddd,'RF_matrix.dat'); rewrite(ddd);
  { Calculate And Write 2D-Receptive Field }
  for j:=nj+1 downto 0 do begin
      for i:=0 to ni+1 do begin
          x:=(i-ni/2)*dxy_LGN;  y:=(j-nj/2)*dxy_LGN;
          if y<0 then d_cen:=sqr(x/sgm_cen_h)+sqr(y/sgm_cen_v1)
                 else d_cen:=sqr(x/sgm_cen_h)+sqr(y/sgm_cen_v2);
          d_sur:=sqr(x/sgm_sur_h)+sqr(y/sgm_sur_v);
          {********************************************************************}
          zRF[i,j]:=         dexp(-d_cen)/pi/sgm_cen_h/(sgm_cen_v1+sgm_cen_v2)*2
                 - k_cen_sur*dexp(-d_sur)/pi/sgm_sur_h/sgm_sur_v;
          {********************************************************************}
          { Writing }
          writeln(ccc,x:9:5,' ',y:9:5,' ',zRF[i,j]:8:4);
          write(ddd,' ',zRF[i,j]:8:4);
      end;
      writeln(ddd);
  end;
  close(ccc);
  close(ddd);
end;

procedure Write2D_zScreen_zview;
var i,j :integer;
    ccc :text;
    x,y :double;
begin
  { Opening }
  assign(ccc,'ScreenAndField.dat'); rewrite(ccc);
  writeln(ccc,'ZONE T="RF.dat"');
  writeln(ccc,'I=',ni+2:3,',J=',nj+2:3,',K=1,F=POINT');
  { Calculate And Write 2D-Receptive Field }
  for j:=nj+1 downto 0 do begin
      for i:=0 to ni+1 do begin
          x:=(i-ni/2)*dxy_LGN;  y:=(j-nj/2)*dxy_LGN;
          writeln(ccc,x:9:5,' ',y:9:5,' ',zScreen[i,j]:8:4,' ',Pz^[i,j]:8:4);
      end;
  end;
  close(ccc);
end;

procedure LGN_InitialConditions;
var i,j :integer;
begin
  { Parameters }
  LGN_Parameters;
  MeanLum:=Background;
//  if LGN_Form1.ComboBox1.ItemIndex in [1,3] then MeanLum:=MeanLum+AmplOfStimLum/2;
  t_LGN:=0;
  nt_LGN:=0;
  LGN_Form1.DDSpinEdit8.Value:=t_LGN*1000;
  { Initial conditions }
  for i:=0 to ni+1 do begin
      for j:=0 to nj+1 do begin
          zScreen[i,j]:=MeanLum;
          zD_cen[i,j]:=MeanLum;
          zD_sur[i,j]:=MeanLum;
          zU_cen[i,j]:=MeanLum;
          zU_sur[i,j]:=MeanLum;
          zU_late[i,j]:=MeanLum;
          zD_late[i,j]:=MeanLum;
          zLGN_cen[i,j]:=MeanLum;
          zLGN_sur[i,j]:=MeanLum;
          zD_cen_Sust[i,j]:=MeanLum{*3.5};                 //*3.5 introduced on 15.04.2019
          zD_sur_Sust[i,j]:=MeanLum{*3.5};
          zU_cen_Sust[i,j]:=MeanLum{*3.5};
          zU_sur_Sust[i,j]:=MeanLum{*3.5};
          zU_late_Sust[i,j]:=MeanLum{*3.5};
          zD_late_Sust[i,j]:=MeanLum{*3.5};
          zLGN_subthr[i,j]:=L_spont +
                            MeanLum/pi*( 1/(sgm_cen_h*(sgm_cen_v1+sgm_cen_v2)/2)
                                -k_cen_sur/(sgm_sur_h*sgm_sur_v));
          zLGN[i,j]:=max(0,zLGN_subthr[i,j]);
          zLGN_Off[i,j]:=max(0,2*L_spont-zLGN_subthr[i,j]);
          dzLGN_dt[i,j]:=0;
      end;
  end;
  LGN_Form1.LineSeries1.Clear;
  LGN_Form1.Series8.Clear;
  LGN_Form1.Series9.Clear;
//  LGN_Form1.LineSeries1.AddXY(t*1000,zLGN[trunc(ni/2),trunc(nj/2)]);
  DrawReceptiveField;
  Application.ProcessMessages;
  CalculateAndWrite2DReceptiveField;
  Diagram.Trace[0]:=zLGN[trunc(ni/2),trunc(nj/2)];
end;

{******************************************************************************}
{******************************************************************************}

function LGN_Screen_Projection_to_Cortex(r_V1,phi_V1 :double) :double;
{  Interpolate screen luminance at the given cortical point
   with the polar coordinates in V1: "r_V1", "phi_V1".
}
var
    ii,jj                      :integer;
    S1,S2,S3,S4,xRF,yRF,z_     :double;
begin
  Translate_r_phi_V1_to_x_y_LGN(r_V1,phi_V1, xRF,yRF);
  ii:=trunc(xRF/dxy_LGN);  ii:=imin(ii,ni);  ii:=imax(ii,0);
  jj:=trunc(yRF/dxy_LGN);  jj:=imin(jj,nj);  jj:=imax(jj,0);
  S1:=(dxy_LGN-xRF+ii*dxy_LGN)*(dxy_LGN-yRF+jj*dxy_LGN);
  S2:=(dxy_LGN-xRF+ii*dxy_LGN)*(yRF-jj*dxy_LGN);
  S3:=(xRF-ii*dxy_LGN)       *(dxy_LGN-yRF+jj*dxy_LGN);
  S4:=(xRF-ii*dxy_LGN)       *(yRF-jj*dxy_LGN);
  z_:=(zScreen[ii,jj]  *S1 + zScreen[ii,jj+1]  *S2
     + zScreen[ii+1,jj]*S3 + zScreen[ii+1,jj+1]*S4)/dxy_LGN/dxy_LGN;
  LGN_Screen_Projection_to_Cortex:=z_;
end;

procedure Translate_r_phi_V1_to_x_y_LGN(r,phi :double; var x,y :double);
begin
  x:=ni2_LGN*dxy_LGN + r*V1_to_LGN_deg_per_mm*1000*cos(phi);
  y:=nj2_LGN*dxy_LGN + r*V1_to_LGN_deg_per_mm*1000*sin(phi);
end;

procedure LGN_Draw_RF(r_V1,phi_V1,fi,charge :double);
var
    iRF,jRF                                                           :integer;
    cos_,sin_,xRF,yRF,dx1,dx2,dx3,dx4,dy1,dy2,dy3,dy4, r_,phi_,x_,y_,
    dx1_,dx2_,dx3_,dx4_,dy1_,dy2_,dy3_,dy4_,xx_Off,sgm_               :double;
{                    x1,y1

           x2,y2
                   .
                       x3,y3

             x4,y4

  (x1,y1) -> ( sgm_pref,        0)
  (x2,y2) -> (        0, sgm_orth)
  (x3,y3) -> ( sgm_pref,-sgm_orth)
  (x4,y4) -> (-sgm_pref,        0)
}
begin
  Translate_r_phi_V1_to_x_y_LGN(r_V1,phi_V1, xRF,yRF);
  iRF:=trunc(xRF/dxy_LGN);
  jRF:=trunc(yRF/dxy_LGN);
  sin_:=sin(fi/2+pi/2);
  cos_:=cos(fi/2+pi/2);
  { Reverse rotation matrix ( cos, -sin )
                            ( sin,  cos )   }
  dx1:= sgm_pref*cos_/dxy_LGN;
  dy1:= sgm_pref*sin_/dxy_LGN;
  dx2:=-sgm_orth*sin_/dxy_LGN;
  dy2:= sgm_orth*cos_/dxy_LGN;
  dx3:= sgm_orth*sin_/dxy_LGN;
  dy3:=-sgm_orth*cos_/dxy_LGN;
  dx4:=-sgm_pref*cos_/dxy_LGN;
  dy4:=-sgm_pref*sin_/dxy_LGN;
  { Shift RF center along big RF-axis }
  xx_Off:=-Off_shift*charge;
  sgm_:=min(sgm_pref,sgm_orth);
  dx1_:= (sgm_     + xx_Off)*cos_/dxy_LGN;
  dy1_:= (sgm_     + xx_Off)*sin_/dxy_LGN;
  dx2_:=(-sgm_*sin_+ xx_Off*cos_)/dxy_LGN;
  dy2_:= (sgm_*cos_+ xx_Off*sin_)/dxy_LGN;
  dx3_:= (sgm_*sin_+ xx_Off*cos_)/dxy_LGN;
  dy3_:=(-sgm_*cos_+ xx_Off*sin_)/dxy_LGN;
  dx4_:=(-sgm_     + xx_Off)*cos_/dxy_LGN;
  dy4_:=(-sgm_     + xx_Off)*sin_/dxy_LGN;
  LGN_Form15.Frame15.Series8.Active:=true;
  LGN_Form15.Frame15.Series8.Clear;
  LGN_Form15.Frame15.Series5.Clear;
  LGN_Form15.Frame15.Series9.Clear;
  LGN_Form15.Frame15.Series12.Clear;
  LGN_Form15.Frame15.Series5.AddXY(xRF/dxy_LGN,    yRF/dxy_LGN);
  LGN_Form15.Frame15.Series9.AddXY(xRF/dxy_LGN,    yRF/dxy_LGN);
  if charge>0 then begin
     LGN_Form15.Frame15.Series9.AddXY(xRF/dxy_LGN+dx1,yRF/dxy_LGN+dy1)
  end else begin
     LGN_Form15.Frame15.Series9.AddXY(xRF/dxy_LGN+dx4,yRF/dxy_LGN+dy4);
  end;
  case DS_model of
  0,2,3,4: begin
       { On-domain of RF }
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx1,yRF/dxy_LGN+dy1);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx2,yRF/dxy_LGN+dy2);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx3,yRF/dxy_LGN+dy3);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx4,yRF/dxy_LGN+dy4);
     end;
  1: begin  {Shift Off around On }
       { On-domain of RF }
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx1,yRF/dxy_LGN+dy1);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx2,yRF/dxy_LGN+dy2);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx3,yRF/dxy_LGN+dy3);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx4,yRF/dxy_LGN+dy4);
       { Off-domain of RF }
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx1_,yRF/dxy_LGN+dy1_);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx2_,yRF/dxy_LGN+dy2_);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx3_,yRF/dxy_LGN+dy3_);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx4_,yRF/dxy_LGN+dy4_);
     end;
  5: begin  { Shift On around Off }
       { Off-domain of RF }
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx1,yRF/dxy_LGN+dy1);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx2,yRF/dxy_LGN+dy2);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx3,yRF/dxy_LGN+dy3);
       LGN_Form15.Frame15.Series12.AddXY(xRF/dxy_LGN+dx4,yRF/dxy_LGN+dy4);
       { On-domain of RF }
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx1_,yRF/dxy_LGN+dy1_);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx2_,yRF/dxy_LGN+dy2_);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx3_,yRF/dxy_LGN+dy3_);
       LGN_Form15.Frame15.Series8.AddXY(xRF/dxy_LGN+dx4_,yRF/dxy_LGN+dy4_);
     end;
  end;
//  LGN_Form15.Frame15.Chart1.Canvas.EllipseWithZ(xRF,yRF,xRF+25,yRF+25,0);
//  LGN_Form15.Canvas.Ellipse(xRF,yRF,xRF+25,yRF+25);
//  LGN_Form15.Frame15.Series8.AddXY(xRF,yRF);
{  LGN_Form15.Frame15.Series8.X0:=iRF-trunc(sgm_orth/dxy_LGN);
  LGN_Form15.Frame15.Series8.Y0:=jRF-trunc(sgm_pref/dxy_LGN);
  LGN_Form15.Frame15.Series8.X1:=iRF+trunc(sgm_orth/dxy_LGN);
  LGN_Form15.Frame15.Series8.Y1:=jRF+trunc(sgm_pref/dxy_LGN);}
  Application.ProcessMessages;
end;

procedure LGN_Draw_Retinotopy(r_0_0, phi_0_0,  r_0_nj, phi_0_nj,
                              r_ni_0,phi_ni_0, r_ni_nj,phi_ni_nj :double);
{ Boundary of the cortical area back-projection }
var x_,y_ :double;
begin
  LGN_Form15.Frame15.Series11.Clear;
  Translate_r_phi_V1_to_x_y_LGN(r_0_0,  phi_0_0, x_,y_);
  LGN_Form15.Frame15.Series11.AddXY(x_/dxy_LGN,  y_/dxy_LGN);
  Translate_r_phi_V1_to_x_y_LGN(r_0_nj, phi_0_nj, x_,y_);
  LGN_Form15.Frame15.Series11.AddXY(x_/dxy_LGN,  y_/dxy_LGN);
  Translate_r_phi_V1_to_x_y_LGN(r_ni_nj,phi_ni_nj, x_,y_);
  LGN_Form15.Frame15.Series11.AddXY(x_/dxy_LGN,  y_/dxy_LGN);
  Translate_r_phi_V1_to_x_y_LGN(r_ni_0, phi_ni_0, x_,y_);
  LGN_Form15.Frame15.Series11.AddXY(x_/dxy_LGN,  y_/dxy_LGN);
  Translate_r_phi_V1_to_x_y_LGN(r_0_0,  phi_0_0, x_,y_);
  LGN_Form15.Frame15.Series11.AddXY(x_/dxy_LGN,  y_/dxy_LGN);
  Application.ProcessMessages;
end;

procedure Define_z_view;
begin
  case LGN_Form1.RadioGroup1.ItemIndex of
  0: Pz:=@zScreen;
  1: Pz:=@zScreen_Sat;
  2: Pz:=@zD_cen;
  3: Pz:=@zD_sur;
  4: Pz:=@zLGN_cen;
  5: Pz:=@zLGN_sur;
  6: Pz:=@zLGN_subthr;
  7: Pz:=@zLGN;
  8: Pz:=@zRF;
  9: Pz:=@zLGN_Off;
  10:Pz:=@zLGN_Sust;
  end;
  if LGN_Form1.RadioGroup1.ItemIndex in [0,1] then IfGray:=1 else IfGray:=0;
end;

function Nonlinearity(z :double):double;
var  f :double;
begin
  f:=z;
  if ShapeOfSaturation='Half of Sigmoid' then begin
     f:=ScaleOfSaturation*(2/(1+dexp(-2*z/ScaleOfSaturation))-1)
  end else if ShapeOfSaturation='Broken-line' then begin
     if z>ScaleOfSaturation then  f:=ScaleOfSaturation;
  end else if ShapeOfSaturation='Sigmoid' then begin
     f:=2*AmplOfStimLum*(1/(1+dexp(-(z-Background-MeanStimLum)/ScaleOfSaturation)));
  end;
  Nonlinearity:=f;
end;

procedure WriteNonlinearFunction;
var
  ccc :text;
  i :integer;
  x :double;
begin
  if ScaleOfSaturation=0 then exit;
  { Opening }
  assign(ccc,'NonlinearFunction.dat'); rewrite(ccc);
  { Writing }
  for i:=0 to 500 do begin
      x:=ScaleOfSaturation/100*i;
      writeln(ccc,x:10:3,' ',Nonlinearity(x):13:3);
  end;
  close(ccc);
end;

{******************************************************************************}
procedure LGN_RunOneStep(t_,dt_ :double);
{******************************************************************************}
var
    i,j                                       :integer;
    pext,znew_,dzdt_,zLGN_Sust_subthr_        :double;
begin
  LGN_Parameters;
  { Saccades }
  if LGN_Form33.Visible then begin
     ni2_Screen:=trunc(ni/2 + Saccades.X[trunc(t_*1000{ms}/Saccades.dt_in_ms)]/dxy_LGN);
     nj2_Screen:=trunc(nj/2 + Saccades.Y[trunc(t_*1000{ms}/Saccades.dt_in_ms)]/dxy_LGN);
  end;
  { Screen }
  for i:=0 to ni+1 do begin
      for j:=0 to nj+1 do begin
          case LGN_Form1.ComboBox1.ItemIndex of
          0: { Bar }        Bar(i,j,pext);
          1: { Gratings }           MovingGratings(t_,i,j,pext);
          2: { delta-function } if (i<>ni2_Screen)or(j<>nj2_Screen) then pext:=0;
          3: { Gradient }   Gradient(i,j,pext);
          4: { Spot }       Spot(i,j,pext);
          5: { Ring }       Ring(i,j,pext);
          6: { Complex stimulus }   ComplexStimulus(t_,i,j,pext);
          7: { Gratings in circle }  MovingGratings(t_,i,j,pext);
          8: { RF with squares }    RF_with_squares(t_,dt_,i,j,pext);
          end;
          zScreen[i,j]:=pext;
          { End of stimulation }
          if t_>t_stim then zScreen[i,j]:=Background;
      end;
  end;
  { Saturation }
  for i:=0 to ni+1 do  for j:=0 to nj+1 do  zScreen_Sat[i,j]:=zScreen[i,j];
  if ScaleOfSaturation<>0 then begin
     for i:=0 to ni+1 do  for j:=0 to nj+1 do begin
         zScreen_Sat[i,j]:=Nonlinearity(zScreen[i,j]);
     end;
  end;
  { Integrate Screen in time }
  for i:=0 to ni+1 do begin
      for j:=0 to nj+1 do begin
          New_m4(dt_/tau_late,zScreen_Sat[i,j], zD_late[i,j],zU_late[i,j]);
          New_m4(dt_/tau_cen, zScreen_Sat[i,j], zD_cen[i,j], zU_cen[i,j]);
          New_m4(dt_/tau_sur, zScreen_Sat[i,j], zD_sur[i,j], zU_sur[i,j]);
          zE_cen[i,j]:=zD_cen[i,j]-K_late_to_early*zD_late[i,j];
          zE_sur[i,j]:=zD_sur[i,j]-K_late_to_early*zD_late[i,j];
          { Sustained }
          if DS_model in [2,3] then begin
          New_m4(dt_/tau_late/3.5,zScreen_Sat[i,j]{*3.5}, zD_late_Sust[i,j],zU_late_Sust[i,j]);        //commented on 15.04.2019
          New_m4(dt_/tau_cen/3.5, zScreen_Sat[i,j]{*3.5}, zD_cen_Sust[i,j], zU_cen_Sust[i,j]);
          New_m4(dt_/tau_sur/3.5, zScreen_Sat[i,j]{*3.5}, zD_sur_Sust[i,j], zU_sur_Sust[i,j]);
          zE_cen_Sust[i,j]:=zD_cen_Sust[i,j]-K_late_to_early*zD_late_Sust[i,j];
          zE_sur_Sust[i,j]:=zD_sur_Sust[i,j]-K_late_to_early*zD_late_Sust[i,j];
          end;
      end;
  end;
  { Spatial filtering }
  for i:=0 to ni+1 do begin
      for j:=0 to nj+1 do {if if_ni_nj_ne_1(i,j) then} begin
          if (IfRunOneLGNneuron=0) or
             ((i=Diagram.i_RecNrn)and(j=Diagram.j_RecNrn)) then begin
              PoissonEq_without_Symmetry(i,j, sgm_cen_h,sgm_cen_v1,sgm_cen_v2,Background, @zE_cen, @zLGN_cen);
              PoissonEq_without_Symmetry(i,j, sgm_sur_h,sgm_sur_v, sgm_sur_v, Background, @zE_sur, @zLGN_sur);
              { Sustained }
              if DS_model in [2,3] then begin
              PoissonEq_without_Symmetry(i,j, sgm_cen_h,sgm_cen_v1,sgm_cen_v2,Background, @zE_cen_Sust, @zLGN_cen_Sust);
              PoissonEq_without_Symmetry(i,j, sgm_sur_h,sgm_sur_v, sgm_sur_v, Background, @zE_sur_Sust, @zLGN_sur_Sust);
              end;
          end;
      end;
  end;
  { Summation and rectification }
  for i:=0 to ni+1 do begin
      for j:=0 to nj+1 do begin
          if (IfRunOneLGNneuron=0) or
             ((i=Diagram.i_RecNrn)and(j=Diagram.j_RecNrn)) then begin
               { DOG }
               zLGN_subthr[i,j] :=L_spont + zLGN_cen[i,j]
                                - k_cen_sur*zLGN_sur[i,j]
                                    {+ (k_cen_sur-1)*Background};
               znew_:=max(0,zLGN_subthr[i,j]);
               { Lagged field }
               if (dt_>0)and(t_>2*dt_) then dzdt_:=(znew_-zLGN[i,j])/dt_           // Current dzLGN_dt
                                       else dzdt_:=0;
               dzLGN_dt[i,j]:=dzLGN_dt[i,j] + dt_/0.020{s}*(dzdt_-dzLGN_dt[i,j]);  // Filtering of dzLGN_dt
               { On- field }
               zLGN[i,j]:=znew_;
               { Off- field }
               zLGN_Off[i,j]:=max(0,2*L_spont - zLGN_subthr[i,j]);
               if LGN_Form1.CheckBox4.Checked then zLGN_Off[i,j]:=zLGN[i,j];
               { Sustained field }
               if DS_model in [2,3] then begin
                  zLGN_Sust_subthr_:=L_spont + zLGN_cen_Sust[i,j]
                                   - k_cen_sur*zLGN_sur_Sust[i,j];
                  zLGN_Sust[i,j]:=max(0,zLGN_Sust_subthr_);
               end else  zLGN_Sust[i,j]:=0;
          end;
      end;
  end;
  LGN_Form1.DDSpinEdit8.Value:=t_*1000;
end;
{******************************************************************************}

procedure LGN_Draw(t_ :double);
var nt_,n_Draw_ :integer;
begin
  Define_z_view;
  { Draw single LGN cell's response }
  LGN_Form1.LineSeries1.AddXY(t_*1000, zLGN[Diagram.i_RecNrn,Diagram.j_RecNrn]);
  LGN_Form1.Series8.AddXY(t_*1000,zLGN_Sust[Diagram.i_RecNrn,Diagram.j_RecNrn]);
  LGN_Form1.Series9.AddXY(t_*1000,      Pz^[Diagram.i_RecNrn,Diagram.j_RecNrn]);
  { Saccades }
  if LGN_Form33.Visible then begin
     LGN_Form33.Series2.Clear;
     nt_:=trunc(t_*1000{ms}/Saccades.dt_in_ms);
     LGN_Form33.Series2.AddXY(Saccades.X[nt_], Saccades.Y[nt_]);
  end;
  { Draw Lattice }
  n_draw_:=trunc(LGN_Form15.DDSpinEdit34.Value);
  if nt_LGN mod n_draw_ = 0 then begin
     Draw_Lattice(Pz, ni,nj,rPW, IfGray);
  end;
//  Application.ProcessMessages;
end;

procedure WriteTraceInFile;
var FName :string;
    Year, Month, Day, Hour, Min, Sec, MSec: Word;
    bbb :text;
    t1 :string;
    i :integer;
    t,fi0 :double;
begin
  { File name }
  DecodeTime(Now, Hour, Min, Sec, MSec);
  fi0:=LGN_Form1.DDSpinEdit5.Value{degrees};
  Str(fi0:3:0,t1);
  FName := IntToStr(Hour) + '_' + IntToStr(Min) + '_' + IntToStr(Sec)+'_fi0='+t1+'.dat';
  { Writing signals }
  assign(bbb,FName); rewrite(bbb);
  i:=0;
  repeat    i:=i+1;
    t:=i*dt_LGN;
    if LGN_Form1.CheckBox1.Checked then begin
       writeln(bbb,t*1000:10:3,' ',Diagram.Trace[i]:10:3);
    end else begin
       writeln(bbb,                Diagram.Trace[i]:10:3);
    end;
  until t>=t_end;
  close(bbb);
end;

procedure RunTillTheEnd;
var  k   :integer;
     fi_ :double;
begin
  LGN_InitialConditions;
  repeat  nt_LGN:=nt_LGN+1;
    t_LGN:=t_LGN+dt_LGN;
//    LGN_Form1.DDSpinEdit8.Value:=t_LGN*1000;
    {***************************}
    LGN_RunOneStep(t_LGN,dt_LGN);
    {***************************}
    { LGN projection to V1 }
    if (IfRunOneLGNneuron=0)and
       (LGN_Form1.PageControl1.ActivePageIndex=1) then begin
        LGN_Form1.Series1.Clear;
        for k:=0 to 180 do begin
            fi_:=k/180*pi;
            zV1[k]:=LGN_Convolve_with_ElongatedGaussian(0,0,fi_,0,0);
            LGN_Form1.Series1.AddXY(fi_/pi*180,zV1[k])
        end;
    end;
    { Remember the trace - LGN central neuron's response }
    Diagram.Trace[nt_LGN]:=zLGN[Diagram.i_RecNrn,Diagram.j_RecNrn];
    { Draw }
    if (nt_LGN<=1)or(nt_LGN mod 10 = 0)or(dt_LGN>=0.001) then LGN_Draw(t_LGN);
  until t_LGN>=t_end;
  WriteTraceInFile;
end;

{******************************************************************************}
procedure RunEntireDiagram;
{******************************************************************************}
var iOrientation,nt_end_,nt_ :integer;
    fi0,max_,x,y,av_,maxAxis :double;
begin
  LGN_Form1.LineSeries2.Clear;
  LGN_Form1.Series2.Clear;
  for iOrientation:=0 to 8 do begin
      { Define orientation fi0 }
      fi0:=45*iOrientation;
      LGN_Form1.DDSpinEdit5.Value:=fi0;
      {************}
      RunTillTheEnd;
      {************}
      { Insert the trace in the array of traces }
      nt_end_:=nt_LGN;
      for nt_:=1 to nt_end_ do begin
          Diagram.Traces[iOrientation,nt_]:=Diagram.Trace[nt_];
      end;
      { Analysis }
      max_:=0;  av_:=0;
      for nt_:=1 to nt_end_ do begin
          if Diagram.Trace[nt_]>max_ then max_:=Diagram.Trace[nt_];
          if nt_end_>0 then av_:=av_+Diagram.Trace[nt_]/nt_end_ else av_:=0;
      end;
      { Take into account the absolute latency }
      av_:=(av_*t_end + L_spont*0.030{s})/(t_end+0.030{s});  // 30ms - absolute latency
      { Plotting }
      x:= av_*cos((fi0+90){degrees}/180*pi);
      y:= av_*sin((fi0+90){degrees}/180*pi);
      LGN_Form1.Series2.AddXY(x,y);
      x:=max_*cos((fi0+90){degrees}/180*pi);
      y:=max_*sin((fi0+90){degrees}/180*pi);
      LGN_Form1.LineSeries2.AddXY(x,y);
      Application.ProcessMessages;
      { Scales of the plot }
      LGN_Form1.Chart3.LeftAxis.Automatic:=false;
      LGN_Form1.Chart3.BottomAxis.Automatic:=false;
      maxAxis:=abs(y)+3;
      maxAxis:=max(maxAxis,abs(LGN_Form1.Chart3.BottomAxis.Maximum));
      maxAxis:=max(maxAxis,abs(LGN_Form1.Chart3.BottomAxis.Minimum));
      maxAxis:=max(maxAxis,abs(LGN_Form1.Chart3.LeftAxis.Maximum));
      maxAxis:=max(maxAxis,abs(LGN_Form1.Chart3.LeftAxis.Minimum));
      LGN_Form1.Chart3.BottomAxis.Maximum:= maxAxis;
      LGN_Form1.Chart3.BottomAxis.Minimum:=-maxAxis;
      LGN_Form1.Chart3.LeftAxis.Maximum  := maxAxis;
      LGN_Form1.Chart3.LeftAxis.Minimum  :=-maxAxis;
      Application.ProcessMessages;
      { Writing }
  end;
end;

end.
